<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Traits\TResponse;
use FM\Service\Fm00000000HabilidadesService;

class Fm00000000HabilidadesController {
    use TResponse;

    protected $habilidadeService;

    public function __construct(Fm00000000HabilidadesService $Fm00000000HabilidadesService)
    {
        $this->habilidadeService = $Fm00000000HabilidadesService;
    }
    // FUNÇÕES DO FRAME PRINCIPAL HABILIDADES
    public function getHabilidades() {
        try {
            $data = $this->habilidadeService->getHabilidades();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarHabilidades(Request $request){
        try {
            $params = $request->getParameters();
            $data = $this->habilidadeService->salvarHabilidades($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirHabilidades(Request $request){
        try {
            $params = $request->getParameters();
            $data = $this->habilidadeService->excluirHabilidades($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    // FUNÇÕES TAB OEPRADORES
    public function getOperadorHabilidade(Request $request) {
        try {
            $data = $this->habilidadeService->getOperadorHabilidade($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function relacionarOperadorHabilidade(Request $request){
        try {
            $data = $this->habilidadeService->relacionarOperadorHabilidade($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirOperadorHabilidades(Request $request){
        try {
            $params = $request->getParameters();
            $data = $this->habilidadeService->excluirOperadorHabilidades($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // FUNÇÕES TAB ATIVIDADES
    public function getAtividadeHabilidade(Request $request) {
        try {
            $data = $this->habilidadeService->getAtividadeHabilidade($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function relacionarAtividadeHabilidade(Request $request){
        try {
            $data = $this->habilidadeService->relacionarAtividadeHabilidade($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirAtividadeHabilidades(Request $request, Response $response){
        try {
            $params = $request->getParameters();
            $data = $this->habilidadeService->excluirAtividadeHabilidades($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}