<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm070000ParametrosSensorFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getParamLeitContPessoas()
    {
        $sql = "SELECT FCM_PARAMLEITCONTPESSOAS.NRPARAMLEITCONTPESSOAS, FCM_PARAMLEITCONTPESSOAS.CDCLIENTE, FCM_PARAMLEITCONTPESSOAS.IDTIPOSENSOR, FCM_PARAMLEITCONTPESSOAS.IDMACDEVICE, FCM_PARAMLEITCONTPESSOAS.IDSENSOR, 
                       FCM_PARAMLEITCONTPESSOAS.NRQTPESSOASALERT, FCM_PARAMLEITCONTPESSOAS.VRDISTANCIAMINLEIT, FCM_PARAMLEITCONTPESSOAS.VRDISTANCIAMAXLEIT, FCM_PARAMLEITCONTPESSOAS.VRDISTANCIAMEDLEIT,
                       FCM_PARAMLEITCONTPESSOAS.QTMATRIZLEITURA, FCM_PARAMLEITCONTPESSOAS.QTTEMPRECONHECIMENTO, FCM_PARAMLEITCONTPESSOAS.IDMODODISTANCIA, FCM_PARAMLEITCONTPESSOAS.QTTEMPOREPETLEIT, FCM_PARAMLEITCONTPESSOAS.HRINICIODIA, 
                       FCM_PARAMLEITCONTPESSOAS.HRFINALDIA, FCM_PARAMLEITCONTPESSOAS.IDATIVO, FCM_PARAMLEITCONTPESSOAS.NRLOCALCLIENTE, FCM_PARAMLEITCONTPESSOAS.DSSENSOR, FCM_PARAMLEITCONTPESSOAS.DATARESET, 
                       FCM_PARAMLEITCONTPESSOAS.IDMONITORAMENTO, FCM_PARAMLEITCONTPESSOAS.NRSEQLEITURA, FCM_PARAMLEITCONTPESSOAS.QTPESSOAS,FCM_PARAMLEITCONTPESSOAS.IPATUALIZASENSORES,CLIENTE.NMFANTCLIE
                    FROM FCM_PARAMLEITCONTPESSOAS 
                    JOIN CLIENTE 
                    ON CLIENTE.CDCLIENTE = FCM_PARAMLEITCONTPESSOAS.CDCLIENTE";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirSensor($parametros)
    {
        $sql = "INSERT INTO FCM_PARAMLEITCONTPESSOAS (NRPARAMLEITCONTPESSOAS, CDCLIENTE, IDTIPOSENSOR, IDMACDEVICE, IDSENSOR, NRQTPESSOASALERT, VRDISTANCIAMINLEIT, VRDISTANCIAMAXLEIT, VRDISTANCIAMEDLEIT,
                     QTMATRIZLEITURA, QTTEMPRECONHECIMENTO, IDMODODISTANCIA, QTTEMPOREPETLEIT, HRINICIODIA, HRFINALDIA, IDATIVO, 
                     NRLOCALCLIENTE, DSSENSOR, DATARESET, IDMONITORAMENTO, NRSEQLEITURA, QTPESSOAS, IPATUALIZASENSORES) 
                    VALUES (:NRPARAMLEITCONTPESSOAS, :CDCLIENTE, :IDTIPOSENSOR, :IDMACDEVICE, :IDSENSOR, :NRQTPESSOASALERT, :VRDISTANCIAMINLEIT, :VRDISTANCIAMAXLEIT, :VRDISTANCIAMEDLEIT, 
                    :QTMATRIZLEITURA, :QTTEMPRECONHECIMENTO, :IDMODODISTANCIA, :QTTEMPOREPETLEIT, :HRINICIODIA, :HRFINALDIA, :IDATIVO,
                    :NRLOCALCLIENTE, :DSSENSOR, SYSDATE, :IDMONITORAMENTO, :NRSEQLEITURA, :QTPESSOAS, :IPATUALIZASENSORES)";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarSensor($parametros)
    {
        $sql = "UPDATE FCM_PARAMLEITCONTPESSOAS
               SET  CDCLIENTE = :CDCLIENTE,
                    IDTIPOSENSOR = :IDTIPOSENSOR,
                    IDMACDEVICE = :IDMACDEVICE,
                    IDSENSOR = :IDSENSOR,
                    NRQTPESSOASALERT = :NRQTPESSOASALERT,
                    VRDISTANCIAMINLEIT = :VRDISTANCIAMINLEIT,
                    VRDISTANCIAMAXLEIT = :VRDISTANCIAMAXLEIT,
                    VRDISTANCIAMEDLEIT = :VRDISTANCIAMEDLEIT,
                    QTMATRIZLEITURA = :QTMATRIZLEITURA,
                    QTTEMPRECONHECIMENTO = :QTTEMPRECONHECIMENTO,
                    IDMODODISTANCIA = :IDMODODISTANCIA,
                    QTTEMPOREPETLEIT = :QTTEMPOREPETLEIT,
                    HRINICIODIA = :HRINICIODIA,
                    HRFINALDIA = :HRFINALDIA,
                    IDATIVO = :IDATIVO,
                    NRLOCALCLIENTE = :NRLOCALCLIENTE,
                    DSSENSOR = :DSSENSOR,
                    DATARESET = SYSDATE,
                    IDMONITORAMENTO = :IDMONITORAMENTO,
                    NRSEQLEITURA = :NRSEQLEITURA,
                    QTPESSOAS = :QTPESSOAS,
                    IPATUALIZASENSORES = :IPATUALIZASENSORES
                WHERE NRPARAMLEITCONTPESSOAS  = :NRPARAMLEITCONTPESSOAS";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deletarParametrosSensor($parametros)
    {
        $sql = "DELETE FROM FCM_PARAMLEITCONTPESSOAS WHERE NRPARAMLEITCONTPESSOAS  = :NRPARAMLEITCONTPESSOAS";
        $this->connection->executeStatement($sql, $parametros);
    }
}
