/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ALIQ                                                     */
/* Tabela : ALIQUOTA                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ALIQ'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ALIQ
GO

CREATE TRIGGER DTULTATU_ALIQ
ON ALIQUOTA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ALIQUOTA', null, 'NRALIQUOTA=' + NRALIQUOTA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ALIQUOTA
      SET DTULTATUALIQ = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ALIQUOTA.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(ALIQUOTA.DTINIVALID,CONVERT(DATETIME,'31/12/1899')) =
             ISNULL(INSERTED.DTINIVALID,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(ALIQUOTA.VRPERREDBC,0)   = ISNULL(INSERTED.VRPERREDBC,0))   AND
            (ISNULL(ALIQUOTA.VRPARDEDUZ,0)   = ISNULL(INSERTED.VRPARDEDUZ,0))   AND
            (ISNULL(ALIQUOTA.VRALIQUOTA,0)   = ISNULL(INSERTED.VRALIQUOTA,0))   AND
            (ISNULL(ALIQUOTA.CDIMPOSTO,0)    = ISNULL(INSERTED.CDIMPOSTO,0))    AND
            (ISNULL(ALIQUOTA.IDENTRSAIDAL,0) = ISNULL(INSERTED.IDENTRSAIDAL,0)) AND
            (ISNULL(ALIQUOTA.CDEMPRESA,0)    = ISNULL(INSERTED.CDEMPRESA,0))    AND
            (ISNULL(ALIQUOTA.CDINSCESTA,0)   = ISNULL(INSERTED.CDINSCESTA,0))   AND
            (ISNULL(ALIQUOTA.CDGRUPOFISC,0)  = ISNULL(INSERTED.CDGRUPOFISC,0))  AND
            (ISNULL(ALIQUOTA.CDPAISORIG,0)   = ISNULL(INSERTED.CDPAISORIG,0))   AND
            (ISNULL(ALIQUOTA.SGESTAORIG,0)   = ISNULL(INSERTED.SGESTAORIG,0))   AND
            (ISNULL(ALIQUOTA.CDPAISDEST,0)   = ISNULL(INSERTED.CDPAISDEST,0))   AND
            (ISNULL(ALIQUOTA.SGESTADEST,0)   = ISNULL(INSERTED.SGESTADEST,0))   AND
            (ISNULL(ALIQUOTA.CDMUNIORIG,0)   = ISNULL(INSERTED.CDMUNIORIG,0))   AND
            (ISNULL(ALIQUOTA.VRINIFAIXA,0)   = ISNULL(INSERTED.VRINIFAIXA,0))   AND
            (ISNULL(ALIQUOTA.VRFIMFAIXA,0)   = ISNULL(INSERTED.VRFIMFAIXA,0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ALIQ','5.05.059';
GO

