/* eslint-disable */
import {
 Http, IDictionary, Metadata,
} from '@zeedhi/core';
import {
  AlertService, DialogService, LoadingService, Select, Text,
} from '@zeedhi/common';

export class TabBillingParametersController {
  private NRPARCNEGOCIO = window.location.search.split('?')[1];

  public mountInformation() {
    const NRPARCNEGOCIO = this.NRPARCNEGOCIO;

     Http.post('/getBillingParameter', { NRPARCNEGOCIO }).then((response: IDictionary) => {
      response.data.dataset.parameter.forEach((data: IDictionary) => {
        Metadata.getInstance<Text>('NRPARAMFATURA').text = data.NRPARAMFATURA;
        Metadata.getInstance<Select>('form-filial').setValue(data.CDFILIALFATURA);
        Metadata.getInstance<Select>('form-invoiceSeries').setValue(data.CDSERIENF);
      });
    });
  }

  public saveBillingParameter() {
    const SERIENF = Metadata.getInstance<Select>('form-invoiceSeries').value;
    const NRPARAMFATURA = Metadata.getInstance<Text>('NRPARAMFATURA').text;

    Http.post('/billingParameter', {
      NRPARCNEGOCIO: this.NRPARCNEGOCIO,
      NRPARAMFATURA: (NRPARAMFATURA === '') ? null : NRPARAMFATURA,
      CDFILIALFATURA: Metadata.getInstance<Select>('form-filial').value,
      CDSERIENF: (SERIENF === null) ? null : SERIENF.CDSERIE,
      CDEMPRESA: (SERIENF === null) ? null : SERIENF.CDEMPRESA,
      CDINSCESTA: (SERIENF === null) ? null : SERIENF.CDINSCESTA,
      CDINSCMUNI: (SERIENF === null) ? null : SERIENF.CDINSCMUNI,
      CDOPERADOR: localStorage.getItem('CDOPERADOR'),
    }).then((response: IDictionary) => {
      const returnMessage = response.data.dataset.parameter[0];
      if (returnMessage === 'OK') {
        this.alertMessages('Paramêtro de Faturamento salvo com sucesso!', 'success');
        this.mountInformation();
      } else {
        this.dialogMessage('Operação bloqueada! Este Parâmetro de Faturamento não pôde ser salvo.<br><br>Se o problema persistir entre em contato com o suporte.');
      }
    });
    LoadingService.hide();
  }

  public alertMessages(message: string, type: string) {
    AlertService.show({
      name: 'basic-alert',
      text: message,
      top: true,
      left: false,
      timeout: 3000,
      color: type,
    });
  }

  public dialogMessage(message: string) {
    DialogService.show({
      name: 'warning-dialog',
      type: 'warning',
      title: 'Erro!',
      text: message,
    });
  }
}